unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids, Buttons;

type
  TForm1 = class(TForm)
    clearBtn: TButton;
    StringGrid1: TStringGrid;
    PaintBox1: TPaintBox;
    PaintBox2: TPaintBox;
    Label1: TLabel;
    Image1: TImage;
    okBtn: TButton;
    msgtext: TStaticText;
    goBtn: TSpeedButton;
    Label3: TLabel;
    circuittext: TStaticText;
    Label2: TLabel;
    Label4: TLabel;
    Image2: TImage;
    demoBtn1: TSpeedButton;
    demoBtn2: TSpeedButton;
    demoBtn3: TSpeedButton;
    demoBtn4: TSpeedButton;
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure PaintBox2Paint(Sender: TObject);
    procedure clearBtnClick(Sender: TObject);
    procedure okBtnClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure goBtnClick(Sender: TObject);
    procedure StringGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure demoBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type TElement = record
                 valid : boolean;
                 enabled : boolean;//part of search
                 active : boolean; //not blocked during search
                 ctIn,ctOut : byte;//0: no element
                end;
     Tcontact = record
                 level : byte;
                 source : byte; //element nr
                end;
     Tcircuit = record
                 elmt : byte;    //[0]:length  []1..15]: element
                 sign : shortInt;//1: in--> out; -1: out--> in
                end;
     TDemo = record
              ch : char;
              c1 : byte;
              c2 : byte;
             end;

     TAdemo = array[1..15] of Tdemo;
     PAdemo = ^TAdemo;

const elmntnames = 'ABCDEFGHKMNPQRS';

      demo1 : array[1..4] of Tdemo =
              ((ch:'A'; c1: 1; c2: 2),
               (ch:'B'; c1: 2; c2: 3),
               (ch:'C'; c1: 3; c2: 4),
               (ch:'D'; c1: 4; c2: 1));

      demo2 : array[1..9] of Tdemo =
              ((ch:'A'; c1: 1; c2: 2),
               (ch:'B'; c1: 2; c2: 3),
               (ch:'C'; c1: 3; c2: 4),
               (ch:'D'; c1: 6; c2: 1),
               (ch:'E'; c1: 4; c2: 5),
               (ch:'F'; c1: 1; c2: 6),
               (ch:'G'; c1: 1; c2: 6),
               (ch:'H'; c1: 5; c2: 6),
               (ch:'K'; c1: 3; c2: 4));

      demo3 : array[1..9] of Tdemo =
              ((ch:'A'; c1: 1; c2:15),
               (ch:'B'; c1:15; c2: 2),
               (ch:'C'; c1: 2; c2:14),
               (ch:'D'; c1:13; c2:15),
               (ch:'E'; c1: 2; c2:13),
               (ch:'F'; c1:13; c2:14),
               (ch:'G'; c1: 3; c2:14),
               (ch:'H'; c1: 3; c2:13),
               (ch:'K'; c1: 1; c2: 13));

      demo4 : array[1..15] of Tdemo =
              ((ch:'A'; c1: 1; c2: 2),
               (ch:'B'; c1: 2; c2: 3),
               (ch:'C'; c1: 3; c2: 4),
               (ch:'D'; c1: 4; c2: 5),
               (ch:'E'; c1: 1; c2: 8),
               (ch:'F'; c1: 8; c2: 7),
               (ch:'G'; c1: 6; c2: 7),
               (ch:'H'; c1: 5; c2: 6),
               (ch:'K'; c1: 1; c2:10),
               (ch:'M'; c1: 9; c2:10),
               (ch:'N'; c1: 9; c2: 6),
               (ch:'P'; c1: 8; c2:10),
               (ch:'Q'; c1: 9; c2: 7),
               (ch:'R'; c1: 3; c2:10),
               (ch:'S'; c1: 9; c2: 4));

var element : array[1..15] of Telement;
    contact : array[1..15] of Tcontact;
    circuit : array[1..15] of Tcircuit;
    circL   : byte;     //circuit length
    elmntsOK : boolean; //elements OK flag

//-- low level helpers --

procedure paintedges(ctrl : Tcontrol; col1,col2 : longword; w : byte);
//paint edges on parent canvas around control
var x1,y1,x2,y2 : word;
    i : byte;
    par : Tcustomform;
begin
 par := getParentform(ctrl);
 x1 := ctrl.left-w;
 y1 := ctrl.top-w;
 x2 := ctrl.left+ctrl.width+w-1;
 y2 := ctrl.top+ctrl.height+w-1;
 with par.canvas do
  begin
   pen.width := 1;
   for i := 0 to w-1 do
    begin
     pen.color := col1;
     moveto(x2-i,y1+i);
     lineto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     pen.color := col2;
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
    end;
  end;
end;

procedure paintgrid;
var i : word;
begin
 with form1.paintbox1 do with canvas do
  begin
   brush.Color := $ffffff;
   pen.Color := $c0c0c0;
   pen.Width := 1;
   fillrect(rect(0,0,width,height));
   i := 17;
   while i < 450 do
    begin
     moveto(0,i);
     lineto(width,i);
     inc(i,30);
    end;
   i := 15;
   while i < 450 do
    begin
     moveto(i,0);
     lineto(i,height);
     inc(i,30);
    end;
  end;
end;

procedure paintContact(el,n : byte);
//el:element; n:contact
var x : word;
begin
 x := (n-1)*30+1;
 with form1.paintbox2.canvas do
  begin
   brush.style := bsSolid;
   brush.color := $ffffff;
   fillrect(rect(x,1,x+28,50));
   brush.style := bsClear;
   if contact[n].level < 99 then
    begin
     textout(x+8,20,inttostr(contact[n].level));
     textout(x+8, 3,elmntnames[el]);
    end;
  end;
end;

procedure clearContacts;
var i : byte;
begin
 for i := 1 to 15 do
  begin
   contact[i].level := 99;
   contact[i].source :=0;
   paintcontact(i,i);
  end;
end;

procedure showcircuit;
var i : byte;
    s : string;
begin
 s := '';
 if circL > 0 then  
  for i := 1 to circL do s := s + elmntnames[circuit[i].elmt]
  else form1.msgtext.caption := 'no circuit';
 form1.circuittext.caption := s;
end;

procedure clearCircuit;
var i : byte;
begin
 for i := 1 to 15 do
  begin
   circuit[i].elmt := 0;
   circuit[i].sign := 1;
  end;
 circL := 0;//length
 showcircuit;
end;

procedure clearElements;
const mt = '';
var i : byte;
begin
 elmntsOK := false;
 with form1.stringgrid1 do
  for i := 1 to 15 do
   begin
    cells[1,i-1] := mt;
    cells[2,i-1] := mt;
   end;
 for i := 1 to 15 do
  with element[i] do
   begin
    ctIn := 0;
    ctOut := 0;
    valid := false;
    enabled := false;
    active := false;
   end;
end;

procedure Hline(var x1,x2,y: word; el : byte);
//get coordinates of element on horizontal line in grid
begin
 with element[el] do
  begin
   x1 := ctIn*30-15;
   x2 := ctOut*30-15;
   y := el*30-13;
  end;
end;

procedure Vline(var x,y1,y2 : word; n1,n2 : byte);
//coordinates of vertical line between elements A , B
//n1,n2 are contact numbers
var ct : byte;
begin
 if circuit[n1].sign = 1 then ct := element[circuit[n1].elmt].ctOut
  else ct := element[circuit[n1].elmt].ctIn;
 x := ct*30 - 15;
 y1 := circuit[n1].elmt*30 - 13;
 y2 := circuit[n2].elmt*30 - 13;
 if y1 < y2 then
  begin
   inc(y1,6);
   dec(y2,6);
  end
  else begin
        dec(y1,6);
        inc(y2,6);
       end;
end;

procedure paintcircuit(sel : byte);
//sel: source element with red dot
var i,n : byte;
    x,x1,x2,y,y1,y2 : word;
begin
 paintgrid;
 with form1.paintbox1.canvas do
  begin
   brush.Style := bsSolid;
   for i := 1 to 15 do
    if element[i].valid then
     begin
      Hline(x1,x2,y,i);
      pen.width := 3;
      if element[i].enabled then pen.color := $ff0000
       else pen.Color := $c0c0c0;
      moveto(x1,y); lineto(x2,y);
      pen.width := 1;
      pen.color := $000000;
      brush.color := $000000;
      ellipse(x1-5,y-5,x1+6,y+6);
      if i = sel then
       begin
        pen.color := $0000ff;
        brush.color := $0000ff;
       end;
      ellipse(x2-5,y-5,x2+6,y+6);
     end;
//
   n := circL;
   if n > 0 then
    begin
     pen.width := 3;
     pen.color := $000080;
     for i := 1 to n-1 do
      begin
       Vline(x,y1,y2,i,i+1);
       moveto(x,y1);
       lineto(x,y2);
      end;
     Vline(x,y1,y2,n,1);
     moveto(x,y1);
     lineto(x,y2);
    end;
  end;//with form1
end;

//-- high level --

function extractCircuit(ct : byte) : byte;
//ct: contact to work backwards
var ct1,i,n,src : byte;
    circ : array[1..15] of Tcircuit;
begin
 result := 0;
 if contact[ct].level = 99 then exit;
 for i := 1 to 15 do circ[i].elmt := 0;
 n := 0;
 ct1 := ct;
 repeat
  src := contact[ct1].source;
  inc(n);
  circ[n].elmt := src;
  if element[src].ctOut = ct1 then
   begin
    ct1 := element[src].ctIn;
    circ[n].sign := 1;
   end
   else begin
         ct1 := element[src].ctOut;
         circ[n].sign := -1;
        end;
 until ct1 = ct;
 result := n;
 for i := 1 to n do
  begin
   circuit[i].elmt := circ[n-i+1].elmt;
   circuit[i].sign := circ[n-i+1].sign;
  end;
end;

procedure InitSearch(var n : byte);
//get 1st active element;
//n : 1st element  0: no element
var i : byte;
    hit : boolean;
begin
 clearCircuit;
 clearcontacts;
 for i := 1 to 15 do
  element[i].active := element[i].enabled;//reset active elements
 i := 0;
 repeat    //find 1st active element
  inc(i);
  hit := element[i].active;
 until hit or (i=15);
 if hit then n := i else n := 0;
end;

function procGo : byte;
//find shortest circuit
//result 0: Ok; 1: no elements; 2:no circuit
var el1,c1,c2,xlevel : byte;
    xel : byte;             //element
    GO : boolean;
begin
 initsearch(el1);
 if el1 = 0 then begin
                  result := 1;
                  exit;
                 end;
//
 with element[el1] do
  begin
   contact[ctOut].level := 1;
   contact[ctOut].source := el1;
   paintcontact(el1,ctOut);
   active := false;
  end;
 repeat                             //all contacts
  GO := false;
  for xel := 1 to 15 do             //all elements
   begin
    if element[xel].active then
     begin
      c1 := element[xel].ctIn;
      c2 := element[xel].ctOut;
      xlevel := contact[c1].level;
      if xlevel < 99 then
       begin
        inc(xlevel);
        if contact[c2].level > xlevel then
         begin
          contact[c2].level := xlevel;
          contact[c2].source := xel;
          element[xel].active := false;
          paintcontact(xel,c2);
          GO := true;
         end;
       end
       else begin
             xlevel := contact[c2].level;
             if xlevel < 99 then
              begin
               inc(xlevel);
               if contact[c1].level > xlevel then
                begin
                 contact[c1].level := xlevel;
                 contact[c1].source := xel;
                 element[xel].active := false;
                 paintcontact(xel,c1);
                 GO := true;
                end;
              end;
            end;
     end;//if active
   end;//for xel
 until GO = false;
 element[el1].enabled := false; //inactivate source element
 circL := extractCircuit(element[el1].ctIn);
 if circL = 0 then result := 2 else result := 0;
 paintcircuit(el1);
 showcircuit;
end;

//-- events --

procedure TForm1.okBtnClick(Sender: TObject);
//check element list
var i,n1,n2 : byte;
    OK : boolean;
begin
 activecontrol := nil;
 paintgrid;
 for i := 1 to 15 do element[i].valid := false;
 clearContacts;
 clearcircuit;
 msgtext.Caption := '';
 OK := true;
 i := 0;
 repeat
  with stringgrid1 do
   if (length(cells[1,i]) > 0) and (length(cells[2,i]) > 0) then
    begin
     n1 := strtoint(stringgrid1.cells[1,i]);
     n2 := strtoint(stringgrid1.cells[2,i]);
     if (n1 = n2) then
      begin
       msgtext.Caption := 'element '+elmntnames[i+1]+' error: equal contacts';
       OK := false;
      end;
     if OK and (n1 > 0) and (n1 <= 15) and (n2 > 0) and (n2 <= 15) then
      begin
       element[i+1].ctIn := n1;
       element[i+1].ctOut := n2;
       element[i+1].valid := true;
       element[i+1].enabled := true;
      end
      else begin
            msgtext.Caption := 'element '+elmntnames[i+1]+': contact error';
            OK := false;
           end;
    end;
  inc(i);
 until (i = 15) or (OK = false);
 if OK then
  begin
   msgtext.Caption := 'OK';
   paintcircuit(0);
   elmntsOK := true;
  end else elmntsOK := false;
end;

procedure TForm1.goBtnClick(Sender: TObject);
//find shortest circuit
var m : byte;
begin
 if elmntsOk then m := procGO else m := 3;
 case m of
  0 : msgText.Caption := 'circuit found; Press <go> for next';
  1 : msgText.Caption := 'no elements';
  2 : msgText.Caption := 'no circuit; Press <go> for next';
  3 : msgText.Caption := 'Press <restart> to register elements';
 end;//case
end;

procedure TForm1.FormCreate(Sender: TObject);
var i : byte;
begin
 elmntsOK := false;
 with stringgrid1 do
  for i := 1 to 15 do cells[0,i-1] := elmntnames[i];
 for i:= 1 to 15 do contact[i].level := 99; 
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
//char filter for stringgrid
begin
 if key = #8 then exit; //backspace always OK
//
 if activecontrol = stringgrid1 then
  with stringgrid1 do
   if (length(Cells[col,row]) < 2) and (key in ['0'..'9']) then exit;
//
 key := #0;
end;

procedure TForm1.clearBtnClick(Sender: TObject);
begin
 activecontrol := nil;
 clearElements;
 paintgrid;
 clearContacts;
 clearCircuit;
 msgText.Caption := '';
end;

procedure TForm1.FormPaint(Sender: TObject);
var i : byte;
    w,x,y : word;
    s : string;
begin
 y := paintbox1.Top - 20;
 x := paintbox1.left - 15;
 with canvas do
  begin
   font.Style := [];
   font.Height := 18;
   font.Color := $000000;
   font.Name := 'courier new';
   brush.style := bsClear;
   for i := 1 to 15 do
    begin
     s := inttostr(i);
     w := textwidth(s) shr 1;
     textout(x-w+30*i,y,inttostr(i));
    end;
  end;
 paintedges(paintbox1,$000000,$808080,2);
 paintedges(paintbox2,$000000,$808080,2);
 paintedges(image1,$c00000,$ff8000,3);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 paintcircuit(0);
end;

procedure TForm1.PaintBox2Paint(Sender: TObject);
var i : word;
begin
 with paintbox2 do with canvas do
  begin
   brush.Color := $ffffff;
   brush.Style := bsSolid;
   pen.Color := $000000;
   pen.Width := 1;
   fillrect(rect(0,0,width,height));
   i := 30;
   while i < 450 do
    begin
     moveto(i,0);
     lineto(i,height);
     inc(i,30);
    end;
  end;
 for i := 1 to 15 do paintcontact(contact[i].source,i); //==
end;

procedure TForm1.StringGrid1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 elmntsOK := false;
end;

procedure TForm1.demoBtn1Click(Sender: TObject);
var p : PAdemo;
    elcount,n,nr,tg : byte;
begin
 p := nil;
 elcount := 0;
 tg := Tspeedbutton(sender).tag;
 case tg of
  1 : begin
       p := @demo1;
       elcount := high(demo1);
      end;
  2 : begin
       p := @demo2;
       elcount := high(demo2);
      end;
  3 : begin
       p := @demo3;
       elcount := high(demo3);
      end;
  4 : begin
       p := @demo4;
       elcount := high(demo4);
      end;
 end;
 clearElements;
 clearcontacts;
 clearcircuit;
 paintgrid;
 msgtext.caption := 'loaded demo '+inttostr(tg);
 for n := 1 to elcount do
  with p^[n] do
   begin
    nr := pos(ch,elmntnames)-1;
    stringgrid1.cells[1,nr] := inttostr(c1);
    stringgrid1.cells[2,nr] := inttostr(c2);
   end;
end;

end.
